package imgclient;

import java.io.*;
import java.net.Socket;

public class JFileSender {
	public static final int BUFF_SIZE = 0x400;
	public static final int BUFF_MASK = 0x3FF;
	
	private Socket m_sock = null;
	private byte[] m_data = new byte[BUFF_SIZE];
	
	private DataOutputStream m_sout = null;
	private FileInputStream m_fin = null;
	private File m_file = null;
	
	private int m_fileSize;
	private int m_blockSize;
	private int m_blockCnt;
	
	public void setSocket(Socket sock) {
		m_sock = sock;
	}
	
	public void sendFile(String fileName) {
		int i;
		byte[] buff = null;
		
		try {
			try {
				m_sout = new DataOutputStream(m_sock.getOutputStream());
				m_file = new File(fileName);
				m_fin = new FileInputStream(m_file);
				
				m_fileSize = (int)m_file.length();
				m_blockCnt = (m_fileSize + BUFF_SIZE - 1) / BUFF_SIZE;
				
				System.out.format("block = %d\n", m_blockCnt);
				
				buff = JDataCOM.int2byte(m_blockCnt);
				
				m_sout.write(buff, 0, 4);
				m_sout.flush();
				for (i = 0; i < m_blockCnt; ++i) {
					m_blockSize = m_fin.read(m_data, 0, BUFF_SIZE);
					
					//buff = JDataCOM.int2byte(m_blockSize);
					//m_sout.write(buff, 0, 4);
					
					System.out.format("i = %d, cnt = %d, block size = %d\n", i, m_blockCnt, m_blockSize);
					m_sout.write(m_data, 0, m_blockSize);
					m_sout.flush();
					//Thread.sleep(15)
				}
				
			} finally {
				//if (m_sout != null) m_sout.close();
				if (m_fin != null) m_fin.close();
			}
		}  catch (Exception e) {
            e.printStackTrace();
        }
	}
}
