package qsl.learn;

import android.app.Activity;
import android.app.Dialog;
import android.content.Intent;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Toast;

/**
 * 主页面，提供了三个按钮，分别对应相应功能
 * 
 * 
 */
public class MainActivity extends Activity implements OnClickListener {

	@Override
	protected void onCreate(Bundle savedInstanceState) {

		super.onCreate(savedInstanceState);

		setContentView(R.layout.main);
		findViewById(R.id.startpanorama).setOnClickListener(this);
		// findViewById(R.id.panoramaview).setOnClickListener(this);
		findViewById(R.id.viewlist).setOnClickListener(this);
		findViewById(R.id.exit).setOnClickListener(this);
	}

	
	public void onClick(View v) {
		switch (v.getId()) {
		case R.id.startpanorama:
			Intent startIntent = new Intent(MainActivity.this,
					MypanoramaActivity.class);
			startActivity(startIntent);
			break;
		// case R.id.panoramaview:
		// Intent viewIntent = new Intent(MainActivity.this,
		// MyPhotoActivity.class);
		// startActivity(viewIntent);
		// break;
		case R.id.viewlist:
			Intent listIntent = new Intent(MainActivity.this,
					PhotoListActivity.class);
			startActivity(listIntent);
			break;
		case R.id.exit:
			MainActivity.this.finish();
			break;
		default:
			break;
		}

	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {

		MenuInflater inflater = new MenuInflater(this);
		inflater.inflate(R.menu.main_menu, menu);
		return super.onCreateOptionsMenu(menu);
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case R.id.about:
			Toast.makeText(this, "拍摄时注意保持水平，并且通过平移来拍摄下一张图片",
					Toast.LENGTH_LONG).show();
			break;
		case R.id.exit_app:
			MainActivity.this.finish();
			break;

		default:
			break;
		}

		return super.onOptionsItemSelected(item);
	}

}
