package qsl.learn;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.ColorMatrix;
import android.graphics.ColorMatrixColorFilter;
import android.graphics.Paint;
import android.util.AttributeSet;
import android.view.View;

/**
 * 使用ColorMatrix对图片处理的一个View控件。
 * 
 * @author i0345
 * 
 */
public class MyPhoto extends View {
	public static final String BITMAP_NAME = "bitmap.jpg";
	private Bitmap mBitmap;
	private Paint mPaint = new Paint(Paint.ANTI_ALIAS_FLAG);
	private float[] array = new float[20];
	private float mAngle;

	public MyPhoto(Context context, AttributeSet attrs) {
		super(context, attrs);
		// mBitmap = BitmapFactory.decodeFile(Environment
		// .getExternalStorageDirectory() + BITMAP_NAME);
		mBitmap = BitmapFactory.decodeResource(context.getResources(),
				R.drawable.arizona_0277);
		invalidate();
	}

	public void setValue(float[] a) {
		for (int i = 0, k = a.length; i < k; i++) {
			array[i] = a[i];
		}

	}

	@Override
	protected void onDraw(Canvas canvas) {

		super.onDraw(canvas);

		Paint paint = mPaint;
		paint.setColorFilter(null);
		canvas.drawBitmap(mBitmap, 0, 0, paint);

		ColorMatrix cm = new ColorMatrix();
		cm.set(array);
		paint.setColorFilter(new ColorMatrixColorFilter(cm));
		canvas.drawBitmap(mBitmap, 0, 0, paint);
	}
}
