package qsl.learn;


/**
 * 包含了用作指示照相的小球和水平线
 * 
 * 
 * 
 */
import android.content.Context;
import android.graphics.*;
import android.util.Log;
import android.widget.ImageView;

public class MyPhotoLineView extends ImageView{

	
	//垂直偏移量，其实是传感器的X轴旋转值
	private double shift_x;
	private double shift_x_temp;
	private double shift_x_diff; 
	//垂直偏移量，其实是传感器的Y轴旋转值
	private double shift_y;
	//垂直偏移量，其实是传感器的Z轴旋转值
	private double shift_z;
	//标志当前是第几张图
	private int flag;
	private int mScreenHeight=0;
	private int mScreenWidth=0;
	public MyPhotoLineView(Context context) {
		super(context);
		// TODO Auto-generated constructor stub
		//mSensorManager = (SensorManager)context.getSystemService(Context.SENSOR_SERVICE);
		//Sensor sensor = mSensorManager.getDefaultSensor(Sensor.TYPE_ACCELEROMETER);
		//mSensorManager.registerListener(this, mSensorManager.getDefaultSensor(Sensor.TYPE_ORIENTATION),
		//		SensorManager.SENSOR_DELAY_GAME);
		shift_x = 0;
		shift_x_temp=shift_x;
		shift_x_diff=Math.abs(shift_x-shift_x_temp);
		shift_y = 0;
		shift_z = 0;
		flag = 0;
	}
	public MyPhotoLineView(Context context,int mScreenHeight,int mScreenWidth) {
		super(context);
		this.mScreenHeight= mScreenHeight;
		this.mScreenWidth = mScreenWidth;
		shift_x = 0;
		shift_x_temp=shift_x;
		shift_x_diff=Math.abs(shift_x-shift_x_temp);
		shift_y = 0;
		shift_z = 0;
		flag = 0;
	}

	//@SuppressLint("DrawAllocation")
	@Override
	protected void onDraw(Canvas canvas) {
		// TODO Auto-generated method stub
		super.onDraw(canvas);
		if(mScreenHeight ==0 || mScreenWidth == 0){
			Log.e("Error","Error in onDraw() in MyPhotoLineView.java");
			return;
		}
		Paint mLinePaint = new Paint();
		mLinePaint.setColor(Color.WHITE);
		mLinePaint.setStyle(Paint.Style.STROKE);
		  //绘制模式
		PathEffect effect = new DashPathEffect(new float[] { 5, 5, 5, 5}, 1);
		mLinePaint.setAntiAlias(true);
		mLinePaint.setPathEffect(effect);
		mLinePaint.setStrokeWidth(4);
		Path path = new Path();
		//角度换弧度;
		double shift_x_copy = shift_y * Math.PI/180.0;
		//虚线路径
	    path.moveTo(0,(float)(mScreenHeight*0.5-mScreenWidth*Math.tan(shift_x_copy)*0.5));
	    path.lineTo(mScreenWidth,(float)(mScreenWidth*Math.tan(shift_x_copy)*0.5+mScreenHeight*0.5));
		canvas.drawPath(path, mLinePaint);
		if(flag>0){
			//画圆球
			Paint mCirclePaint = new Paint();
			mCirclePaint.setColor(Color.WHITE);
			shift_x_diff=Math.abs(shift_x-shift_x_temp);
			//中心圆球
//			canvas.drawCircle((float)(mScreenWidth*0.5), (float)(mScreenHeight*0.5)
//					, (float) 10.0, mCirclePaint);
			//左侧圆球
			canvas.drawCircle((float)(mScreenWidth*0.33+5*(shift_x-shift_x_temp)), (float)(mScreenHeight*0.5-1/6.0*mScreenWidth*Math.tan(shift_x_copy))
					, (float) 8.0, mCirclePaint);
			//右侧圆球
			canvas.drawCircle((float)(mScreenWidth*0.67+5*(shift_x-shift_x_temp)), (float)(mScreenHeight*0.5+1/6.0*mScreenWidth*Math.tan(shift_x_copy))
					, (float) 8.0, mCirclePaint);
			
		}
		
	}

	public void setShift_X(double shift_x){
		if(flag==2 || flag ==3){
			this.shift_x = shift_x;
			if(shift_x_temp==0){
				shift_x_temp = shift_x;
			}
		}else{
			this.shift_x=0;
		}
	}
	public void setShift_Y(double shift_y){
		this.shift_y = shift_y;
	}
	public void setShift_Z(double shift_z){
			this.shift_z = shift_z;
	}
	public boolean setFlag(int flag){
		if(flag>3 || flag<1){
			return false;
		}else{
			this.flag = flag;
			return true;
		}
	}
	
	public double getShift_x_diff(){
		return shift_x_diff;
	}

}
