package qsl.learn;

import android.app.ListActivity;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.ContextMenu;
import android.view.ContextMenu.ContextMenuInfo;
import android.view.LayoutInflater;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView.AdapterContextMenuInfo;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.SimpleCursorAdapter;
import android.widget.TextView;
import com.bitss.tk.image.*;
/**
 * 图片列表类，虽然用相应的缩略图来显示了，但是还有待优化，因为它是直接加载所有图片
 * 
 * 
 * 
 */
public class PhotoListActivity extends ListActivity {

	private PhotoDbAdapter mDbHelper;
	private Cursor mNotesCursor;

	@Override
	protected void onCreate(Bundle savedInstanceState) {

		super.onCreate(savedInstanceState);

		setContentView(R.layout.list);
		mDbHelper = new PhotoDbAdapter(this);

		fillData();

		registerForContextMenu(getListView());

	}

	private void fillData() {
		mDbHelper.open();
		mNotesCursor = mDbHelper.fetchAllPhotos();
		startManagingCursor(mNotesCursor);
		// TODO ....PhotoDbAdapter.KEY_PATH R.id.imageview1
		
//		 String[] from = new String[] { PhotoDbAdapter.KEY_NAME,
//		 PhotoDbAdapter.KEY_PATH };
//		
//		 int[] to = new int[] { R.id.text1, R.id.imageview1 };
//		 ImageListAdapter photoadapter = new ImageListAdapter(this,
//		 R.layout.photo_item, mNotesCursor, from, to);

		// 用baseadapter的实现
		ImageAdapter photoadapter = new ImageAdapter(mNotesCursor);

		setListAdapter(photoadapter);
		mDbHelper.close();
	}

	@Override
	protected void onListItemClick(ListView l, View v, int position, long id) {
		super.onListItemClick(l, v, position, id);
		Log.d("photolistclick", "ItemClick,,position:" + position + "  id:"
				+ id);
		Intent intent = new Intent(PhotoListActivity.this,
				SpecialActivity.class);
		intent.putExtra(PhotoDbAdapter.KEY_ROWID, id);
		startActivity(intent);

	}

	@Override
	protected void onDestroy() {
		if (mDbHelper != null) {
			mDbHelper.close();
			mDbHelper = null;
		}

		super.onDestroy();
	}

	@Override
	public void onCreateContextMenu(ContextMenu menu, View v,
			ContextMenuInfo menuInfo) {
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.menu.list_menu, menu);

		super.onCreateContextMenu(menu, v, menuInfo);
	}

	@Override
	public boolean onContextItemSelected(MenuItem item) {
		AdapterContextMenuInfo info = (AdapterContextMenuInfo) item
				.getMenuInfo();
		switch (item.getItemId()) {
		case R.id.delete:
			deletePicById(info.id);
			fillData();
			return true;
		case R.id.show:
			Intent intent = new Intent(PhotoListActivity.this,
					ShowPanoramaActivity.class);
			intent.putExtra(PhotoDbAdapter.KEY_ROWID, info.id);
			startActivity(intent);

			return true;

		default:

			return super.onContextItemSelected(item);

		}

	}

	private void deletePicById(long id) {
		// TODO Auto-generated method stub
		PhotoDbAdapter photoDbAdapter = new PhotoDbAdapter(this);
		photoDbAdapter.open();
		Cursor cursor = photoDbAdapter.fetchPhoto(id);
		if (cursor.moveToFirst()) {
			String path = cursor.getString(cursor
					.getColumnIndex(PhotoDbAdapter.KEY_PATH));
			Log.d("EffectPhotoActivity", "get the path:" + path);
			PhotoUtil.deleteFileByPath(path);

		}
		photoDbAdapter.deletePhoto(id);
		cursor.close();
		cursor = null;
		photoDbAdapter.close();
	}

	/**
	 * 继承simperCursorAdapter的实现。
	 * 
	 * @author i0345
	 * 
	 */
	private class ImageListAdapter extends SimpleCursorAdapter {
		private LayoutInflater inflater;

		public ImageListAdapter(Context context, int layout, Cursor c,
				String[] from, int[] to) {
			super(context, layout, c, from, to);
			// TODO Auto-generated constructor stub
		}

		@Override
		public void bindView(View view, Context context, Cursor cursor) {
			LinearLayout linearLayout = null;
			if (view == null) {
				linearLayout = (LinearLayout) inflater.inflate(
						R.layout.photo_item, null);
			} else {
				linearLayout = (LinearLayout) view;
			}
			int idxName = cursor.getColumnIndex(PhotoDbAdapter.KEY_NAME);
			int idxPath = cursor.getColumnIndex(PhotoDbAdapter.KEY_PATH);

			TextView textView = (TextView) linearLayout
					.findViewById(R.id.text1);
			ImageView imageView = (ImageView) linearLayout
					.findViewById(R.id.imageview1);
			imageView.setImageDrawable(getResources().getDrawable(
					R.drawable.loading));

			textView.setText(cursor.getString(idxName));

			new ImageLoader().loadBitmap(imageView, cursor.getString(idxPath),
					new ImageCallBack() {

						
						public void imageLoad(ImageView imageView, Bitmap bitmap) {
							// TODO Auto-generated method stub
							imageView.setImageBitmap(bitmap);
						}
					});

		}
	}

	public interface ImageCallBack {
		public void imageLoad(ImageView imageView, Bitmap bitmap);
	}

	class ImageLoader {
		public void loadBitmap(final ImageView imageView, final String string,
				final ImageCallBack imageCallBack) {

			final Handler handler = new Handler() {

				@Override
				public void handleMessage(Message msg) {
					// TODO Auto-generated method stub
					imageCallBack.imageLoad(imageView, (Bitmap) msg.obj);
				}
			};
			
			new Thread(){
				public void run() {
				Bitmap bitmap=	 PhotoUtil.decodeBitmap(string);
				Message message=handler.obtainMessage(0, bitmap);
				handler.sendMessage(message);
					
				};
				
			}.run();
		}

	}

	/**
	 * 继承baseAdapter实现的。
	 * 
	 * @author i0345
	 * 
	 */
	private class ImageAdapter extends BaseAdapter {
		// private LayoutInflater inflater;
		private Bitmap[] bitmaps;
		private String[] names;
		private Long[] id;
		private int count;

		public ImageAdapter(Cursor c) {
			int idxName = c.getColumnIndex(PhotoDbAdapter.KEY_NAME);
			int idxPath = c.getColumnIndex(PhotoDbAdapter.KEY_PATH);
			int idxId = c.getColumnIndex(PhotoDbAdapter.KEY_ROWID);

			if (c != null) {
				count = c.getCount();
				if (count > 0) {
					bitmaps = new Bitmap[count];
					names = new String[count];
					id = new Long[count];
					int i = 0;
					while (c.moveToNext()) {
						bitmaps[i] = PhotoUtil.decodeBitmap(c
								.getString(idxPath));
						names[i] = c.getString(idxName);
						id[i] = c.getLong(idxId);
						i++;
					}

				}

			}
		}

		
		public int getCount() {

			return count;
		}


		public Object getItem(int position) {

			return names[position];
		}

		
		public long getItemId(int position) {

			return id[position];
		}

		
		public View getView(int position, View convertView, ViewGroup parent) {

			LinearLayout linearLayout = null;
			if (convertView == null) {
				LayoutInflater inflater = LayoutInflater
						.from(PhotoListActivity.this);
				linearLayout = (LinearLayout) inflater.inflate(
						R.layout.photo_item, null);
			} else {
				linearLayout = (LinearLayout) convertView;
			}

			TextView textView = (TextView) linearLayout
					.findViewById(R.id.text1);
			ImageView imageView = (ImageView) linearLayout
					.findViewById(R.id.imageview1);

			textView.setText(names[position]);
			imageView.setImageBitmap(bitmaps[position]);
			return linearLayout;
		}

	}
}
