package qsl.learn;

import java.io.File;

import android.R.string;
import android.content.Context;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;

/**
 * 一个图片静态工具类，有从文件取缩略图片的功能，检查是否有相机的功能
 * 
 *
 * 
 */
public class PhotoUtil {

	/**
	 * 从指定文件夹获取图片。。未完成
	 * 
	 * @return
	 */
	public static string[] getPhotoFromFile() {
		File photoFile = new File(Const.PIC_PATH);
		if (photoFile.listFiles(new PhotoFileter()).length > 0) {
			for (File file : photoFile.listFiles(new PhotoFileter())) {
			
			}
		}
		return null;

	}

	/**
	 * @param context
	 * @return 是否有相机
	 */
	public static boolean checkCameraHardware(Context context) {
		if (context.getPackageManager().hasSystemFeature(
				PackageManager.FEATURE_CAMERA)) {
			// this device has a camera
			return true;
		} else {
			// no camera on this device
			return false;
		}
	}

	/**
	 * @param path
	 *            图像的sd卡里面的路径
	 * @param compareSize
	 *            缩放尺寸 至 size 级别，比如100像素，很小。
	 * @return
	 */
	public static Bitmap decodeBitmap(String path, int compareSize) {
		BitmapFactory.Options options = new BitmapFactory.Options();
		options.inJustDecodeBounds = true;
		// 通过这个bitmap获取图片的宽和高
		Bitmap bitmap = BitmapFactory.decodeFile(path, options);
		if (bitmap == null) {
			System.out.println("bitmap为空");
		}
		float realWidth = options.outWidth;
		float realHeight = options.outHeight;
		System.out.println("真实图片高度：" + realHeight + "宽度:" + realWidth);
		// 计算缩放比
		int scale = (int) ((realHeight > realWidth ? realHeight : realWidth) / compareSize);
		if (scale <= 0) {
			scale = 1;
		}
		options.inSampleSize = scale;
		options.inJustDecodeBounds = false;
		// 注意这次要把options.inJustDecodeBounds 设为 false,这次图片是要读取出来的。
		bitmap = BitmapFactory.decodeFile(path, options);
		int w = bitmap.getWidth();
		int h = bitmap.getHeight();
		System.out.println("缩略图高度：" + h + "宽度:" + w);
		return bitmap;
	}

	/**
	 * 快捷的返回 100像素的小图像。
	 * 
	 * @param path
	 * @return
	 */
	public static Bitmap decodeBitmap(String path) {
		return decodeBitmap(path, 100);
	}
	
	public static void deleteFile(File file ) {
		 if(file.exists()){                    //判断文件是否存在
			    if(file.isFile()){                    //判断是否是文件
			     file.delete();                       //delete()方法 你应该知道 是删除的意思;
			    }else if(file.isDirectory()){              //否则如果它是一个目录
			     File files[] = file.listFiles();               //声明目录下所有的文件 files[];
			     for(int i=0;i<files.length;i++){            //遍历目录下所有的文件
			      PhotoUtil.deleteFile(files[i]);             //把每个文件 用这个方法进行迭代
			     } 
			    } 
			    file.delete(); 
			   }else{ 
			    System.out.println("所删除的文件不存在！"+'\n'); 
			   } 

	}
	public static boolean deleteFileByPath(String path){
		File file=new File(path);
		
		deleteFile(file);
		return true;
	}
}
