#include "CImgServer.h"

DWORD WINAPI threadProc(LPVOID lpParameter) {
	CImgServer *pSrv = reinterpret_cast<CImgServer *>(lpParameter);
	return pSrv->run();
}

CImgServer::CImgServer() {}

CImgServer::~CImgServer() {
	closeSocket();
}

bool CImgServer::initSocket() {
	int err;

	m_wVersionRequested = MAKEWORD(1, 1);
	err = WSAStartup(m_wVersionRequested, &m_wsaData);

	if (err) {
		printf("start up failed!\n");
		return false;
	}
	if (LOBYTE(m_wsaData.wVersion) != 1 || HIBYTE(m_wsaData.wVersion) != 1) {
		WSACleanup();
		return false;
	}

	m_server = socket(AF_INET, SOCK_STREAM, 0);
	if (m_server == INVALID_SOCKET) {
		printf("socket failed!\n");
		return false;
	}

	m_addrServer.sin_addr.S_un.S_addr = htonl(INADDR_ANY);
    m_addrServer.sin_family = AF_INET;
    m_addrServer.sin_port = htons(SERVER_PORT);

	err = bind(m_server, reinterpret_cast<SOCKADDR *>(&m_addrServer), sizeof(SOCKADDR));
	if (err == SOCKET_ERROR) {
		printf("bind failed!\n");
		return false;
	}

	listen(m_server, 64);

	printf("init success!\n");

	return true;
}

void CImgServer::closeSocket() {
	closesocket(m_server);
	WSACleanup();
}

bool CImgServer::start() {

	dofMaker = new ImgDoFEffectMaker();
	maker = new ImageFieldDepthMaker();

	m_hThread = CreateThread(NULL, 0, threadProc, reinterpret_cast<LPVOID>(this), 0, NULL);

	printf("Server Start!!!\n");

	return true;
}

void CImgServer::stop() {
	TerminateThread(m_hThread, 0);
	CloseHandle(m_hThread);

	delete dofMaker;
	delete maker;

	printf("Server Stop!!!\n");
}

bool CImgServer::run() {
	int sz = sizeof(SOCKADDR);

	while (1) {
		m_accept = accept(m_server, reinterpret_cast<SOCKADDR *>(&m_addrClient), &sz);

		printf("recv request!\n");

		m_recv.setSocket(m_accept);
		m_recv.recvFile("./left.jpg");


		//m_accept = accept(m_server, reinterpret_cast<SOCKADDR *>(&m_addrClient), &sz);

		m_recv.setSocket(m_accept);
		m_recv.recvFile("./right.jpg");


		//m_accept = accept(m_server, reinterpret_cast<SOCKADDR *>(&m_addrClient), &sz);


		recv(m_accept, reinterpret_cast<char *>(&px), sizeof(px), 0);
		recv(m_accept, reinterpret_cast<char *>(&py), sizeof(py), 0);

		printf("point = [%d, %d]\n", px, py);


		//maker->init(10,10,1);
		maker->LoadPicLeftRight("left.jpg", "right.jpg");
		maker->CMDOperations();
		maker->calFieldDepth();
		maker->getFieldDepth(&ans);

		if (!dofMaker->loadSrcImg("tar_left.jpg")) printf("load pic fail!!!\n");
		else {
			//if (!dofMaker->loadDepInfo("out.txt")) printf("load dep fail!!!\n");
			if (!dofMaker->loadDepInfo(*ans)) printf("load dep fail!!!\n");
			else {
				dofMaker->makeDoFEffect(LEN_DIAM);
				dofMaker->saveDstImg("rslt.jpg");
			}
		}

		m_send.setSocket(m_accept);
		m_send.sendFile("rslt.jpg");

		closesocket(m_accept);

		printf("request solved successfully!!!\n");
	}

	return true;
}
