#include "MeanShiftChopper.h"

void MeanShiftChopper::floodFillPostprocess(Mat& img, map<Scalar, int>& m, const Scalar& colorDiff)
{
	CV_Assert( !img.empty() );
	Mat mask( img.rows+2, img.cols+2, CV_8UC1, Scalar::all(0) );
	for( int y = 0; y < img.rows; y++ )
	{
		for( int x = 0; x < img.cols; x++ )
		{
			if( mask.at<uchar>(y+1, x+1) == 0 )
			{
				Scalar newVal( rng(256), rng(256), rng(256) );
				floodFill( img, mask, Point(x,y), newVal, 0, colorDiff, colorDiff );
			}
		}
	}
}

bool MeanShiftChopper::getPicChopped(Mat* src, Mat* dst, map<Scalar, int>& m){
	pyrMeanShiftFiltering( *src, *dst, spatialRad, colorRad, maxPyrLevel);
	floodFillPostprocess(*dst, m, Scalar::all(2));
	return true;
}

void MeanShiftChopper::InitParameter(int _spatialRad, int _colorRad, int _maxPyrLevel){
	spatialRad = _spatialRad;
	colorRad = _colorRad;
	maxPyrLevel = _maxPyrLevel;
}

MeanShiftChopper::MeanShiftChopper(){
	rng = theRNG();
	spatialRad = 80;
	colorRad = 60;
	maxPyrLevel = 5;
}