#ifndef SIFT_MATCHER_H
#define SIFT_MATCHER_H

#include "sift/imgfeatures.h"
#include "sift/kdtree.h"
#include "sift/sift.h"
#include "sift/utils.h"
#include "sift/xform.h"

#include "config.h"

class SIFTMatcher{
public:
	void clear();
	void ransac(
		vector<pair<point, point>>& point_set,
		vector<vector<unsigned int>> flag, int block);
	int getMatchedPointDuals(vector<pair<point, point>>& point_set,
		IplImage* left,
		IplImage* right);
	SIFTMatcher();
	~SIFTMatcher();
private:
	struct kd_node *root;
	struct feature* feat_left, *feat_right, *t_feat;
	struct feature** nbrs;
	bool processed;
};

#endif