#ifndef CONFIG_H
#define CONFIG_H

#include <opencv/cv.h>
#include <opencv/cxcore.hpp>
#include <opencv/highgui.h>

#include <vector>
#include <string>
#include <list>
#include <queue>
#include <map>
#include <cmath>
#include <stack>

using namespace std;

using namespace cv;

typedef struct _point{
	int x,y;
	_point(int _x, int _y){
		x = _x;
		y = _y;
	}
	_point(){
		x = y = -1;
	}
	_point(const CvPoint& p){
		x = p.x;
		y = p.y;
	}
}point;

typedef struct _bgr_point{
	unsigned char r, g, b;
	_bgr_point(unsigned char _b, unsigned char _g, unsigned _r){
		b = _b;
		g = _g;
		r = _r;
	}
	_bgr_point(){
		b = r = g = 0;
	}
	bool operator == (const _bgr_point& c) const {
		return b == c.b && g == c.g && r == c.r;
	}
	bool operator <(const _bgr_point& c) const {
		int l = b * 255 * 255 + g * 255 + r, t = c.b * 255 * 255 + c.g * 255 + c.r;
		return l < t;
	}
}bgr_point;

typedef struct _dfs_point{
	point p;
	int dir_id;
	_dfs_point(point _p){
		p = _p;
		dir_id = 0;
	}
	_dfs_point(){
		dir_id = 0;
	}
}dfs_point;

#endif